export declare class Tree {
    version: string;
    tree: Node;
    static fromObject(object: Record<string, unknown>): Tree;
}
export declare enum ConstructInfoFqnType {
    STACK = 0,
    STAGE = 1,
    APP = 2,
    CUSTOM_RESOURCE = 3
}
export declare class ConstructInfoFqn {
    static of: (val: string) => ConstructInfoFqn | undefined;
    constructor(cdkType: ConstructInfoFqnType);
    readonly typ: ConstructInfoFqnType;
}
export declare class Node {
    id: string;
    path: string;
    children: Map<string, Node>;
    attributes: Map<string, string | Node | Record<string, string>>;
    constructInfoFqn: ConstructInfoFqn | undefined;
    findInSubTree(predicate: (Node: any) => boolean): Node | null;
    static fromObject(object: Record<string, unknown | Record<string, string>>): Node;
}
