"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiagramOptions = exports.CdkDiaDecorator = exports.CdkDia = void 0;
const customizable_attribute_1 = require("../diagram/component/customizable-attribute");
class CdkDia {
    static decorate(inspector, decorator) {
        const attributes = decorator.build();
        for (const key in attributes) {
            inspector.addAttribute(CdkDia.attrPrefix + key, attributes[key]);
        }
    }
}
exports.CdkDia = CdkDia;
CdkDia.attrPrefix = "CDK-DIA_";
class CdkDiaDecorator {
    constructor() {
        this.attributes = {};
    }
    collapse(val) {
        this.attributes[customizable_attribute_1.CollapssingCustomizer.name] = val;
        return this;
    }
    build() {
        return this.attributes;
    }
}
exports.CdkDiaDecorator = CdkDiaDecorator;
function DiagramOptions(options) {
    return function (target) {
        target.prototype.inspect = function (inspector) {
            const decorator = new CdkDiaDecorator().collapse(options.collapse);
            CdkDia.decorate(inspector, decorator);
        };
    };
}
exports.DiagramOptions = DiagramOptions;
//# sourceMappingURL=construct-decorator.js.map