import * as diagram from "../../diagram";
import { DiagramRenderer, RenderingOutput, RenderingProps } from "../diagram-renderer";
export declare class GraphvizRenderingProps extends RenderingProps {
    diagram: diagram.Diagram;
    path: string;
}
export declare class GraphvizRenderingOutput implements RenderingOutput {
    private imagePath;
    private imageType;
    constructor(imagePath: string, imageType: string);
    userOutput(): void;
}
export declare class Graphviz implements DiagramRenderer {
    render(props: GraphvizRenderingProps): Promise<GraphvizRenderingOutput>;
    renderToDot(dia: diagram.Diagram, targetDotPath: string): void;
    private static generatePng;
    private static sanitizeAndResolvePath;
    private static dotToPng;
    private static GRAPHVIZ_BINARY;
}
